//La clase Contabilidad/*{{{*/
function Contabilidad(docXML){/*{{{*/
  this.id = 0;
  this.docXML = docXML;
  this.empresa = null;
  this.referencia = null;
  this.moneda = null;
  this.digitosPGC = 6;
  this.idCuentaPyG = null;
  this.modificada = false;
  this.fichero = null;
  this.cuenta = new Array();
  this.indiceCuenta = 0;
  this.asiento = new Array();
  this.proveedor = new Array();
  this.cliente = new Array();
  this.tipoAsiento = new Array();
  this.predefinido = new Array();
  this.cuentaPorId = new Array();
    this.cuentaPorId[0] = this;
  this.maxIdCuenta = 0;
  this.maxIdProveedor = -1;
  this.maxIdCliente = -1;
  this.maxIdTipoAsiento = -1;
  this.maxIdDocumento = 0;

  this.cargarXML = cargarXMLContabilidad;
  this.verXML = verXMLContabilidad;
  this.nuevaCuenta = nuevaCuentaContabilidad;
  this.cargarCuenta = cargarCuentaContabilidad;
  this.cargarAsiento = cargarAsientoContabilidad;
  this.nuevoAsiento = nuevoAsientoContabilidad;
  this.verCuentasFinales = verCuentasFinalesContabilidad;
  this.verCuentas = verCuentasContabilidad;
  this.borrarAsiento = borrarAsientoContabilidad;
  this.borrarPredefinido = borrarPredefinidoContabilidad;
  this.nuevoProveedor = nuevoProveedorContabilidad;
  this.cargarProveedor = cargarProveedorContabilidad;
  this.borrarProveedor = borrarProveedorContabilidad;
  this.nuevoCliente = nuevoClienteContabilidad;
  this.nuevoPredefinido = nuevoPredefinidoContabilidad;
  this.cargarCliente = cargarClienteContabilidad;
  this.cargarPredefinido = cargarPredefinidoContabilidad;
  this.borrarCliente = borrarClienteContabilidad;
  this.verCuentaPorId = verCuentaPorIdContabilidad;
  this.buscarAsientos = buscarAsientosContabilidad;
  this.existeCuenta = existeCuentaContabilidad;
  this.cargarTipoAsiento = cargarTipoAsientoContabilidad;
  this.hayAsientosTipo = hayAsientosTipoContabilidad;
  this.borrarTipoAsiento = borrarTipoAsientoContabilidad;
  this.verTipoAsientoPorId = verTipoAsientoPorIdContabilidad;
  this.verNombreCompleto = verNombreCompletoContabilidad;
  this.tieneAsientos = tieneAsientosContabilidad;
  this.borrarCuenta = borrarCuentaContabilidad;
  this.cambiarPadreCuenta = cambiarPadreCuentaContabilidad;

  if (this.docXML != null) this.cargarXML();
}/*}}}*/

function cargarXMLContabilidad(){/*{{{*/
//Carga la contabilidad a partir del fichero XML
  //Leemos los Datos Generales
  this.empresa = docXML.getElementsByTagName("empresa").item(0).attributes.getNamedItem("valor").nodeValue;
  this.nombre = this.empresa;
  this.referencia = docXML.getElementsByTagName("referencia").item(0).attributes.getNamedItem("valor").nodeValue;
  this.moneda = docXML.getElementsByTagName("moneda").item(0).attributes.getNamedItem("valor").nodeValue;
  this.digitosPGC = docXML.getElementsByTagName("digitos_PGC").item(0).attributes.getNamedItem("valor").nodeValue;
  this.idCuentaPyG = docXML.getElementsByTagName("cuenta_PyG").item(0).attributes.getNamedItem("idCuenta").nodeValue;
  var cuentaActual = this;

  //Leemos los Tipos de Asientos
  tiposAsiento = docXML.getElementsByTagName("tipos_asiento").item(0);
  if (tiposAsiento.hasChildNodes()){
    listaTiposAsiento = tiposAsiento.childNodes;
    for(var i=0; i<listaTiposAsiento.length; i++){
      nodoTipoAsiento = listaTiposAsiento.item(i);
      if (nodoTipoAsiento.nodeType == Node.ELEMENT_NODE) //Evitamos los elementos de tipo #text que son tabuladores y RCs
	this.cargarTipoAsiento(nodoTipoAsiento);
    }
  }
  
  //Leemos las Cuentas
  cuentas = docXML.getElementsByTagName("cuentas").item(0);
  if (cuentas.hasChildNodes()){
    listaCuentas = cuentas.childNodes;
    for(var i=0; i<listaCuentas.length; i++){
      nodoCuenta = listaCuentas.item(i);
      if (nodoCuenta.nodeType == Node.ELEMENT_NODE) //Evitamos los elementos de tipo #text que son tabuladores y RCs
	this.cargarCuenta(this, nodoCuenta);
    }
  }

  //Leemos los asientos
  asientos = docXML.getElementsByTagName("asientos").item(0);
  if (asientos.hasChildNodes()){
    listaAsientos = asientos.childNodes;
    for(var i=0; i<listaAsientos.length; i++){
      nodoAsiento = listaAsientos.item(i);
      if (nodoAsiento.nodeType == Node.ELEMENT_NODE) //Evitamos los elementos de tipo #text que son tabuladores y RCs
	this.cargarAsiento(nodoAsiento);
    }
  }

  //Leemos los clientes
  clientes = docXML.getElementsByTagName("clientes").item(0);
  if (clientes.hasChildNodes()){
    listaClientes = clientes.childNodes;
    for(var i=0; i<listaClientes.length; i++){
      nodoCliente = listaClientes.item(i);
      if (nodoCliente.nodeType == Node.ELEMENT_NODE) //Evitamos los elementos de tipo #text que son tabuladores y RCs
	this.cargarCliente(nodoCliente);
    }
  }

  //Leemos los proveedores
  proveedores = docXML.getElementsByTagName("proveedores").item(0);
  if (proveedores.hasChildNodes()){
    listaProveedores = proveedores.childNodes;
    for(var i=0; i<listaProveedores.length; i++){
      nodoProveedor = listaProveedores.item(i);
      if (nodoProveedor.nodeType == Node.ELEMENT_NODE) //Evitamos los elementos de tipo #text que son tabuladores y RCs
	this.cargarProveedor(nodoProveedor);
    }
  }
	  
  //Leemos los Asientos Predefinidos
  predefinidos = docXML.getElementsByTagName("predefinidos").item(0);
  if (predefinidos.hasChildNodes()){
    listaPredefinidos = predefinidos.childNodes;
    for(var i=0; i<listaPredefinidos.length; i++){
      nodoPredefinido = listaPredefinidos.item(i);
      if (nodoPredefinido.nodeType == Node.ELEMENT_NODE) //Evitamos los elementos de tipo #text que son tabuladores y RCs
	this.cargarPredefinido(nodoPredefinido);
    }
  }
  
  //ltimos Detalles
  this.modificada = false;

}/*}}}*/

function buscarAsientosContabilidad(criterio){/*{{{*/
//Obviamente, este mtodo, busca asientos
  var resultado = new Array();
  var encontrado;
  for (var i=0; i<this.asiento.length; i++){
    if ((!criterio.asiento) && (!this.asiento[i].prevision)) continue;
    if ((!criterio.prevision) && (this.asiento[i].prevision)) continue;
    if ((criterio.fechaDesde != null) && (this.asiento[i].fecha < criterio.fechaDesde)) continue;
    if ((criterio.fechaHasta != null) && (this.asiento[i].fecha > criterio.fechaHasta)) continue;
    if ((criterio.tipo != null) && (this.asiento[i].tipo.id != criterio.tipo.id)) continue;
    
    if (criterio.idCuenta != null){
      encontrado = false;
      for(var j=0; j < this.asiento[i].apunte.length; j++)
	if (this.asiento[i].apunte[j].idCuenta == criterio.idCuenta)
	  encontrado = true;
      if (encontrado == false) 
	continue;
    }
    
    if (criterio.importe != ""){
      encontrado = false;
      for(var j=0; j < this.asiento[i].apunte.length; j++)
	if (eval(this.asiento[i].apunte[j].importe) == eval(criterio.importe)) encontrado = true;
      if (encontrado == false) continue;
    }
    
    //El asiento cumple los criterios, asi que, lo aadimos al resultado
    resultado[resultado.length] = this.asiento[i];
  } 
  return resultado; //Lnea de Francisco
}/*}}}*/

function verXMLContabilidad(parametro){/*{{{*/
//Devuelve la contabilidad como un texto XML
//El parmetro, si existe, indica el periodo a descargar.
  var contenido = new String();
	
  var nivelTabulacion = 0;
  //Ponemos la cabecera
  contenido = '<?xml version="1.0" encoding="ISO-8859-15" ?>\n';

  //Contabilidad
  contenido += '<contabilidad>\n';
  nivelTabulacion++;  //Se incrementa despus de abrir un elemento 
  
  //Parmetros
  contenido += tabula(nivelTabulacion) + '<parametros>\n';
  nivelTabulacion++;
  contenido += tabula(nivelTabulacion) + '<empresa valor="'+this.empresa+'"/>\n';
  contenido += tabula(nivelTabulacion) + '<referencia valor="'+this.referencia+'"/>\n';
  //contenido += tabula(nivelTabulacion) + '<moneda valor="'+this.moneda+'"/>\n';
  contenido += tabula(nivelTabulacion) + '<moneda valor=""/>\n';
  contenido += tabula(nivelTabulacion) + '<digitos_PGC valor="'+this.digitosPGC+'"/>\n';
  contenido += tabula(nivelTabulacion) + '<cuenta_PyG idCuenta="'+this.idCuentaPyG+'"/>\n';

  //Tipos de Asiento
  contenido += tabula(nivelTabulacion) + '<tipos_asiento>\n';
  nivelTabulacion++;
  for (var i=0; i<this.tipoAsiento.length; i++)
    contenido += tabula(nivelTabulacion) + '<tipo id="' + this.tipoAsiento[i].id + '" nombre="' + this.tipoAsiento[i].nombre +'" factura="' + this.tipoAsiento[i].factura +'"/>\n';
  nivelTabulacion--;
  contenido += tabula(nivelTabulacion) + '</tipos_asiento>\n';

  //Cierre de Parmetros
  nivelTabulacion--;  //Se decrementa antes de cerrar un elemento
  contenido += tabula(nivelTabulacion) + '</parametros>\n';

  //Cuentas
  contenido += tabula(nivelTabulacion) + '<cuentas>\n';
  nivelTabulacion++;
  for(var i=0; i<this.cuenta.length; i++)
    contenido += this.cuenta[i].verXML(nivelTabulacion);
	
  //Cierre de Cuentas
  nivelTabulacion--;  //Se decrementa antes de cerrar un elemento
  contenido += tabula(nivelTabulacion) + '</cuentas>\n';
  
  //Asientos
  contenido += tabula(nivelTabulacion) + '<asientos>\n';
  nivelTabulacion++;
  for(var i=0; i<this.asiento.length; i++){
    var procesar = true;
    if (parametro)
      if ((this.asiento[i].fecha < parametro.fechaInicio) || (parametro.fechaFin < this.asiento[i].fecha))
	procesar = false;
    if (procesar) contenido += this.asiento[i].verXML(nivelTabulacion);
  }
  
  //Cierre de Asientos
  nivelTabulacion--;  //Se decrementa antes de cerrar un elemento
  contenido += tabula(nivelTabulacion) + '</asientos>\n';
  
  //Proveedores
  contenido += tabula(nivelTabulacion) + '<proveedores>\n';
  nivelTabulacion++;
  for(var i=0; i<this.proveedor.length; i++)
    contenido += this.proveedor[i].verXML(nivelTabulacion);
  
  //Cierre de Proveedores
  nivelTabulacion--;  //Se decrementa antes de cerrar un elemento
  contenido += tabula(nivelTabulacion) + '</proveedores>\n';

  //Clientes
  contenido += tabula(nivelTabulacion) + '<clientes>\n';
  nivelTabulacion++;
  for(var i=0; i<this.cliente.length; i++)
    contenido += this.cliente[i].verXML(nivelTabulacion);
  
  //Cierre de Clientes
  nivelTabulacion--;  //Se decrementa antes de cerrar un elemento
  contenido += tabula(nivelTabulacion) + '</clientes>\n';
        	
  //Predefinidos
  contenido += tabula(nivelTabulacion) + '<predefinidos>\n';
  nivelTabulacion++;
  for(var i=0; i<this.predefinido.length; i++)
    contenido += this.predefinido[i].verXML(nivelTabulacion);
  
  //Cierre de Predefinidos
  nivelTabulacion--;  //Se decrementa antes de cerrar un elemento
  contenido += tabula(nivelTabulacion) + '</predefinidos>\n';

  //Cierre de Contabilidad
  contenido += '</contabilidad>\n';
        	
  return contenido;
}/*}}}*/

function nuevaCuentaContabilidad(idCuentaPadre){ /*{{{*/
//Crea una nueva cuenta y le asigna el id
  cuenta = new Cuenta();
  cuenta.id = ++this.maxIdCuenta;
  this.cuentaPorId[cuenta.id] = cuenta;
  var cuentaPadre = this.verCuentaPorId(idCuentaPadre);
  cuenta.padre = cuentaPadre;
  cuentaPadre.cuenta[cuentaPadre.cuenta.length] = cuenta;

  return cuenta;
}/*}}}*/

function cargarCuentaContabilidad(cuentaPadre, nodoCuenta){ /*{{{*/
//Incluye una cuenta ya existente (del fichero de XML) en la contabilidad y a sus subcuentas
  var cuenta = new Cuenta();
  //Asignamos sus atributos
  cuenta.id = nodoCuenta.attributes.getNamedItem("id").nodeValue;
  cuenta.nombre = nodoCuenta.attributes.getNamedItem("nombre").nodeValue;
  cuenta.tipo = nodoCuenta.attributes.getNamedItem("tipo").nodeValue;
  cuenta.pgc = nodoCuenta.attributes.getNamedItem("pgc").nodeValue;
  cuenta.fin = false;
  if (nodoCuenta.attributes.getNamedItem("fin").nodeValue == 'true') cuenta.fin = true;
  //La incluimos en el array de cuentas indexadas
  this.cuentaPorId[cuenta.id] = cuenta;
  if (parseInt(this.maxIdCuenta) < parseInt(cuenta.id)) this.maxIdCuenta = cuenta.id;
  //Actualizamos la longuitud del Array de la cuenta Padre 
  cuenta.padre=cuentaPadre;
  cuentaPadre.cuenta[cuentaPadre.cuenta.length]=cuenta;
  //Procesamos sus subcuentas
  if (nodoCuenta.hasChildNodes()){
    var listaSubcuentas = nodoCuenta.childNodes;
    for(var i=0; i<listaSubcuentas.length; i++){
      var nodoSubcuenta = listaSubcuentas.item(i);
      if (nodoSubcuenta.nodeType == Node.ELEMENT_NODE) //Evitamos los elementos de tipo #text que son tabuladores y RCs
      this.cargarCuenta(cuenta, nodoSubcuenta)
    }
  }
}/*}}}*/

function cargarAsientoContabilidad(nodoAsiento){/*{{{*/
//Incluye un asiento ya existente (del fichero XML) y sus apuntes
  var asiento = this.nuevoAsiento();
  //Asignamos sus atributos
  asiento.nombre = nodoAsiento.attributes.getNamedItem("nombre").nodeValue;
  var fecha = nodoAsiento.attributes.getNamedItem("fecha").nodeValue;
  var datosfecha = fecha.split("/");
  asiento.fecha = new Date(eval(datosfecha[2]),eval(datosfecha[1] - 1),eval(datosfecha[0]));
  asiento.documento = nodoAsiento.attributes.getNamedItem("documento").nodeValue;
  if (parseInt(this.maxIdDocumento) < parseInt(asiento.documento)) this.maxIdDocumento = asiento.documento;
  if (nodoAsiento.attributes.getNamedItem("prevision").nodeValue == 'true') asiento.prevision = true;
  asiento.tipo = this.verTipoAsientoPorId(nodoAsiento.attributes.getNamedItem("tipo").nodeValue);
  asiento.factura = nodoAsiento.attributes.getNamedItem("factura").nodeValue;
  asiento.notas = nodoAsiento.attributes.getNamedItem("notas").nodeValue;
  //Procesamos sus apuntes
  if (nodoAsiento.hasChildNodes()){
    var listaApuntes = nodoAsiento.childNodes;
    for(var i=0; i<listaApuntes.length; i++){
      var nodo = listaApuntes.item(i);
      if (nodo.nodeType == Node.ELEMENT_NODE){ //Evitamos los elementos de tipo #text que son tabuladores y RCs
	var apunte = asiento.nuevoApunte();
	//apunte.cuenta = this.verCuentaPorId(nodo.attributes.getNamedItem("cuenta").nodeValue);
	//apunte.cuenta = nodo.attributes.getNamedItem("cuenta").nodeValue; //Guardamos el id de la cuenta
	apunte.idCuenta = nodo.attributes.getNamedItem("idCuenta").nodeValue; //Guardamos el id de la cuenta
	apunte.importe = nodo.attributes.getNamedItem("importe").nodeValue;
      }
    }
  }
}/*}}}*/

function nuevoAsientoContabilidad(){/*{{{*/
  nuevoAsiento = new Asiento();
  this.asiento[this.asiento.length] = nuevoAsiento;

  return nuevoAsiento;
}/*}}}*/

function verCuentasFinalesContabilidad(){/*{{{*/
//Devuelve un array con las cuentas finales
  var resultado = new Array();
  for(var i=0;i<this.cuenta.length;i++)
    resultado=resultado.concat(this.cuenta[i].verCuentasFinales());
  return resultado;
}/*}}}*/

function verCuentasContabilidad(){/*{{{*/
//Devuelve un array con las cuentas finales
  var resultado = new Array();
  for(var i=0;i<this.cuenta.length;i++)
    resultado=resultado.concat(this.cuenta[i].verCuentas());
  return resultado;
}/*}}}*/

function borrarAsientoContabilidad(asiento){/*{{{*/
  //Basta con eliminar la referencia en el array de asientos de contabilidad
  var i=0;
  while ((i<this.asiento.length) && (this.asiento[i++] != asiento))
    ;
  while (i<this.asiento.length)
    this.asiento[i - 1] = this.asiento[i++];
  this.asiento[i - 1] = null;
  this.asiento.length--;
}/*}}}*/

function borrarPredefinidoContabilidad(predefinido){/*{{{*/
  //Basta con eliminar la referencia en el array de asientos de contabilidad
  var i=0;
  while ((i<this.predefinido.length) && (this.predefinido[i++] != predefinido))
    ;
  while (i<this.predefinido.length)
    this.predefinido[i - 1] = this.predefinido[i++];
  this.predefinido[i - 1] = null;
  this.predefinido.length--;
}/*}}}*/

function nuevoProveedorContabilidad(){/*{{{*/
  nuevoProveedor = new Proveedor()
  nuevoProveedor.id = ++this.maxIdProveedor;
  this.proveedor[this.proveedor.length] = nuevoProveedor;

  return nuevoProveedor;
}/*}}}*/

function cargarProveedorContabilidad(nodoProveedor){/*{{{*/
  var proveedor = new Proveedor();
  proveedor.id = nodoProveedor.attributes.getNamedItem("id").nodeValue;
  if (parseInt(proveedor.id) > parseInt(this.maxIdProveedor)) this.maxIdProveedor = proveedor.id;
  proveedor.nombre = nodoProveedor.attributes.getNamedItem("nombre").nodeValue;
  proveedor.nif = nodoProveedor.attributes.getNamedItem("nif").nodeValue;
  if (nodoProveedor.attributes.getNamedItem("cuentaBancaria"))
    proveedor.cuentaBancaria = nodoProveedor.attributes.getNamedItem("cuentaBancaria").nodeValue;
  else proveedor.cuentaBancaria = null;
  proveedor.idCuenta = this.verCuentaPorId(nodoProveedor.attributes.getNamedItem("idCuenta").nodeValue);
  
  this.proveedor[this.proveedor.length] = proveedor;

  return proveedor;
}/*}}}*/

function borrarProveedorContabilidad(proveedor){/*{{{*/
  //Basta con eliminar la referencia en el array de proveedores de contabilidad
  var i=0;
  while ((i<this.proveedor.length) && (this.proveedor[i++] != proveedor))
    ;
  while (i<this.proveedor.length)
    this.proveedor[i - 1] = this.proveedor[i++];
  this.proveedor[i - 1] = null;
  this.proveedor.length--;
}/*}}}*/

function nuevoClienteContabilidad(){/*{{{*/
  nuevoCliente = new Cliente()
  nuevoCliente.id = ++this.maxIdCliente;
  this.cliente[this.cliente.length] = nuevoCliente;

  return nuevoCliente;
}/*}}}*/

function nuevoPredefinidoContabilidad(){/*{{{*/
  nuevoPredefinido = new Predefinido();
  this.predefinido[this.predefinido.length] = nuevoPredefinido;

  return nuevoPredefinido;
}/*}}}*/

function cargarClienteContabilidad(nodoCliente){/*{{{*/
  var cliente = new Cliente();
  cliente.id = nodoCliente.attributes.getNamedItem("id").nodeValue;
  if (parseInt(cliente.id) > parseInt(this.maxIdCliente)) this.maxIdCliente = cliente.id;
  cliente.nombre = nodoCliente.attributes.getNamedItem("nombre").nodeValue;
  cliente.nif = nodoCliente.attributes.getNamedItem("nif").nodeValue;
  cliente.idCuenta = this.verCuentaPorId(nodoCliente.attributes.getNamedItem("idCuenta").nodeValue);
  this.cliente[this.cliente.length] = cliente;

  return cliente;
}/*}}}*/

function cargarPredefinidoContabilidad(nodoPredefinido){/*{{{*/
//Incluye un asiento predefinido ya existente (del fichero XML) y sus apuntes
  var predefinido = this.nuevoPredefinido();
  //Asignamos sus atributos
  predefinido.nombre = nodoPredefinido.attributes.getNamedItem("nombre").nodeValue;
  predefinido.tipo = this.verTipoAsientoPorId(nodoPredefinido.attributes.getNamedItem("tipo").nodeValue);
  predefinido.notas = nodoPredefinido.attributes.getNamedItem("notas").nodeValue;
  //Procesamos sus apuntes
  if (nodoPredefinido.hasChildNodes())
    for(var i=0; i<nodoPredefinido.childNodes.length; i++)
      if (nodoPredefinido.childNodes.item(i).nodeType == Node.ELEMENT_NODE){ //Evitamos los elementos de tipo #text que son tabuladores y RCs
	var apunte = predefinido.nuevoApunte();
	apunte.idCuenta = nodoPredefinido.childNodes.item(i).attributes.getNamedItem("idCuenta").nodeValue;
	apunte.formula = nodoPredefinido.childNodes.item(i).attributes.getNamedItem("formula").nodeValue;
      }
  
  return predefinido;
}/*}}}*/

function borrarClienteContabilidad(cliente){/*{{{*/
  //Basta con eliminar la referencia en el array de clientes de contabilidad
  var i=0;
  while ((i<this.cliente.length) && (this.cliente[i++] != cliente))
    ;
  while (i<this.cliente.length)
    this.cliente[i - 1] = this.cliente[i++];
  this.cliente[i - 1] = null;
  this.cliente.length--;
}/*}}}*/

function verCuentaPorIdContabilidad(idCuenta){/*{{{*/
//Devuelve el puntero a la cuenta que tiene el id indicado
  if(idCuenta=="null") return null;
  return this.cuentaPorId[idCuenta];

}/*}}}*/

function tabula(nivelTabulacion){/*{{{*/
  var resultado = new String();
  resultado = "";
  for (var i=0;i<nivelTabulacion;i++)
    resultado += '\t';

  return resultado;
}/*}}}*/

function existeCuentaContabilidad(nombre,pgc){/*{{{*/
  for(var i=0;i<this.cuentaPorId.length;i++){
    if(this.cuentaPorId[i]){
      if((this.cuentaPorId[i].pgc == pgc) && (this.cuentaPorId[i].nombre != nombre) && (pgc!="")) 
        return this.cuentaPorId[i].nombre;
    }
  }
  return false;
}/*}}}*/

function cargarTipoAsientoContabilidad(nodoTipoAsiento){/*{{{*/
  var tipoAsiento = new Object();
  tipoAsiento.id = nodoTipoAsiento.attributes.getNamedItem("id").nodeValue; 
  if (parseInt(tipoAsiento.id) > parseInt(this.maxIdTipoAsiento)) this.maxIdTipoAsiento = tipoAsiento.id;
  tipoAsiento.nombre = nodoTipoAsiento.attributes.getNamedItem("nombre").nodeValue; 
  tipoAsiento.factura = eval(nodoTipoAsiento.attributes.getNamedItem("factura").nodeValue); 

  this.tipoAsiento[this.tipoAsiento.length] = tipoAsiento;

  return tipoAsiento;
}/*}}}*/

function hayAsientosTipoContabilidad(tipoAsiento){/*{{{*/
//Indica si existen asientos de un tipo determinado
  for (var i=0; i<this.asiento.length; i++)
    if (this.asiento[i].tipo == tipoAsiento.id) return true;
  return false;
}/*}}}*/ 

function borrarTipoAsientoContabilidad(tipoAsiento){/*{{{*/
  //Basta con eliminar la referencia en el array de tipos de asientos de contabilidad
  var i=0;
  while ((i<this.tipoAsiento.length) && (this.tipoAsiento[i++] != tipoAsiento))
    ;
  while (i<this.tipoAsiento.length)
    this.tipoAsiento[i - 1] = this.tipoAsiento[i++];
  this.tipoAsiento[i - 1] = null;
  this.tipoAsiento.length--;
}/*}}}*/

function verTipoAsientoPorIdContabilidad(id){/*{{{*/
//Devuelve el objeto TipoAsiento correspondiente al id recibido.
  for (var i=0; i<this.tipoAsiento.length; i++)
    if (this.tipoAsiento[i].id == id) return this.tipoAsiento[i];
  return null;
}/*}}}*/

function verNombreCompletoContabilidad(){/*{{{*/
  return "";
}/*}}}*/

function tieneAsientosContabilidad(idCuenta){/*{{{*/
//Devuelve un booleano indicando si la cuenta tiene asientos
  for (var i=0; i<this.asiento.length; i++)
    for (var j=0; j<this.asiento[i].apunte.length; j++)
      if (this.asiento[i].apunte[j].idCuenta == idCuenta) return true;

  return false;
}/*}}}*/

function borrarCuentaContabilidad(idCuenta){/*{{{*/
  //Basta con eliminar la referencia en el array de cuentas del padre y en el array de cuentas por id
  var i=0;
  cuenta = this.verCuentaPorId(idCuenta);
  while ((i<cuenta.padre.cuenta.length) && (cuenta.padre.cuenta[i++].id != idCuenta))
    ;
  while (i<cuenta.padre.cuenta.length)
    cuenta.padre.cuenta[i - 1] = cuenta.padre.cuenta[i++];
  cuenta.padre.cuenta[i - 1] = null;
  cuenta.padre.cuenta.length--;
  cuenta = null;
  this.cuentaPorId[idCuenta] = null;
}/*}}}*/

function cambiarPadreCuentaContabilidad(cuenta, nuevoPadre){/*{{{*/
//Cambia la cuenta padre de una cuenta
  //Se aade al array de cuentas del nuevo padre
  nuevoPadre.cuenta[nuevoPadre.cuenta.length] = cuenta;
  //Se elimina del array de cuentas del padre actual
  var i=0;
  while ((i<cuenta.padre.cuenta.length) && (cuenta.padre.cuenta[i++] != cuenta))
    ;
  while (i<cuenta.padre.cuenta.length)
    cuenta.padre.cuenta[i - 1] = cuenta.padre.cuenta[i++];
  cuenta.padre.cuenta[i - 1] = null;
  cuenta.padre.cuenta.length--;
  //Reapuntamos su padre
  cuenta.padre = nuevoPadre;
}/*}}}*/

/*}}}*/

//La clase Cuenta/*{{{*/

function Cuenta(){/*{{{*/
  this.id = null;	//Es necesario para relacionar los apuntes con su cuenta
  this.nombre = null;
  this.tipo = null;
  this.pgc = null;
  this.fin = false;
  this.abierta = false;	//Indica si la cuenta se muestra abierta o cerrada en el rbol (no se almacena)
  this.cuenta = new Array();
  this.padre = null;

  this.borrar = borrarCuenta;
  this.verXML = verXMLCuenta;
  this.verCuentasFinales = verCuentasFinalesCuenta;
  this.verCuentas = verCuentasCuenta;
  this.verNombreCompleto = verNombreCompletoCuenta;
  //this.saldar = saldarCuenta;

  return this;
}/*}}}*/

function borrarCuenta(){/*{{{*/
  //Basta con eliminar la referencia en el array de cuentas del padre
  this.cuentaPorId[this.id] = null; //Y en el array de cuentas por id
  var i=0;
  while ((i<this.padre.cuenta.length) && (this.padre.cuenta[i++] != this))
    ;
  while (i<this.padre.cuenta.length)
    this.padre.cuenta[i - 1] = this.padre.cuenta[i++];
  this.padre.cuenta[i - 1] = null;
  this.padre.cuenta.length--;
}/*}}}*/

function verXMLCuenta(nivelTabulacion){/*{{{*/
  var contenido = new String();

  contenido = tabula(nivelTabulacion) + '<cuenta id="' + this.id + '" nombre="' + this.nombre + '" tipo="' + this.tipo + '" pgc="' + this.pgc + '" fin="' + this.fin + '">\n';
  nivelTabulacion++;
  
  for (var i=0; i<this.cuenta.length; i++)
    contenido += this.cuenta[i].verXML(nivelTabulacion);
  
  nivelTabulacion--;
  contenido += tabula(nivelTabulacion) + "</cuenta>\n";

  return contenido;
}/*}}}*/

function verCuentasFinalesCuenta(){/*{{{*/
  var resultado = new Array();
  if (this.fin)
    resultado[0] = this;
  else
    for (var i=0; i<this.cuenta.length; i++)
      resultado = resultado.concat(this.cuenta[i].verCuentasFinales());

  return resultado;
}/*}}}*/

function verCuentasCuenta(){/*{{{*/
//Devuelve una lista lineal de cuentas
  var resultado = new Array();
  resultado[0] = this;
  for (var i=0;i<this.cuenta.length; i++)
    resultado = resultado.concat(this.cuenta[i].verCuentas());

  return resultado;
}/*}}}*/

function verNombreCompletoCuenta(){/*{{{*/
  //Devuelve el nombre completo de la cuenta, incluyendo el de sus padres
  if (this.padre == null)
    return this.nombre;
  else
    return this.padre.verNombreCompleto() + "." + this.nombre;
}/*}}}*/

/*}}}*/

//La clase Asiento/*{{{*/
function Asiento(){/*{{{*/
  this.nombre = null;
  this.fecha = null;
  this.prevision = false;
  this.notas = null;
  this.documento = null;
  this.tipo = null;
  this.factura = null;
  this.apunte = new Array();

  this.verXML = verXMLAsiento;
  this.nuevoApunte = nuevoApunteAsiento;
  this.borrarApunte = borrarApunteAsiento;
  this.borrarApuntes = borrarApuntesAsiento;
  
  return this;
}/*}}}*/

function verXMLAsiento(nivelTabulacion){/*{{{*/
  var contenido = new String();

  var fecha = this.fecha.getDate()+"/"+(this.fecha.getMonth() + 1)+"/"+this.fecha.getFullYear();

  if (this.factura == null) this.factura = "";

  contenido = tabula(nivelTabulacion) + '<asiento nombre="' + this.nombre + '" fecha="' + fecha + '" prevision="' + this.prevision + '" notas="' + this.notas + '" documento="'+ this.documento+'" tipo="' + this.tipo.id + '" factura="' + this.factura + '">\n';
  nivelTabulacion++;
  
  for (var i=0; i<this.apunte.length; i++)
      contenido += this.apunte[i].verXML(nivelTabulacion);

  nivelTabulacion--;
  contenido += tabula(nivelTabulacion) + "</asiento>\n";

  return contenido;
}/*}}}*/

function nuevoApunteAsiento(){/*{{{*/
//Crea un nuevo Apunte en el Asiento;
  nuevoApunte = new Apunte()
  this.apunte[this.apunte.length] = nuevoApunte;

  return nuevoApunte;
}/*}}}*/

function borrarApunteAsiento(apunte){/*{{{*/
  //Basta con eliminar la referencia en el array de apuntes del asiento
  var i=0;
  while ((i<this.apunte.length) && (this.apunte[i++] != apunte))
    ;
  while (i<this.apunte.length)
    this.apunte[i - 1] = this.apunte[i++];
  this.apunte[i - 1] = null;
  this.apunte.length--;
}/*}}}*/

function borrarApuntesAsiento(){/*{{{*/
//Borra todos los apuntes del Asiento
  this.apunte = new Array();
}/*}}}*/

/*}}}*/

//La clase Apunte/*{{{*/
function Apunte(){/*{{{*/
	this.idCuenta = null;
	this.importe = null;

	this.verXML = verXMLApunte;
}/*}}}*/

function verXMLApunte(nivelTabulacion){/*{{{*/
  var contenido = new String();
  contenido = tabula(nivelTabulacion) + '<apunte idCuenta="' + this.idCuenta + '" importe="' + this.importe + '" />\n';

  return contenido;
}/*}}}*/
/*}}}*/

//La clase Proveedor/*{{{*/
function Proveedor(){/*{{{*/
  this.id = null;	//Hace falta para identificar los proveedores en las facturas.
  this.nombre = null;
  this.nif = null;
  this.cuentaBancaria = null;
  this.idCuenta = null;

  this.verXML = verXMLProveedor;
}/*}}}*/

function verXMLProveedor(nivelTabulacion){/*{{{*/
  var contenido = new String();

  contenido = tabula(nivelTabulacion) + '<proveedor id="'+ this.id +'" nombre="' + this.nombre + '" nif="' + this.nif + '" cuentaBancaria="' + this.cuentaBancaria + '" idCuenta="' + this.idCuenta + '"/>\n';

  return contenido;
}/*}}}*/
/*}}}*/

//La clase Cliente/*{{{*/
function Cliente(){/*{{{*/
  this.id = null;
  this.nombre = null;
  this.nif = null;
  this.idCuenta = null;

  this.verXML = verXMLCliente;
}/*}}}*/

function verXMLCliente(nivelTabulacion){/*{{{*/
  var contenido = new String();

  contenido = tabula(nivelTabulacion) + '<cliente id="' + this.id + '" nombre="' + this.nombre + '" nif="' + this.nif + '" idCuenta="' + this.idCuenta + '"/>\n';

  return contenido;
}/*}}}*/
/*}}}*/

//La clase Predefinido/*{{{*/
function Predefinido(){/*{{{*/
  this.nombre = null;
  this.notas = null;
  this.apunte = new Array();

  this.verXML = verXMLPredefinido;
  this.nuevoApunte = nuevoApuntePredefinido;
  this.borrarApunte = borrarApuntePredefinido;
  this.borrarApuntes = borrarApuntesPredefinido;
  
}/*}}}*/

function verXMLPredefinido(nivelTabulacion){/*{{{*/
  var contenido = new String();

  contenido = tabula(nivelTabulacion) + '<predefinido nombre="' + this.nombre + '" tipo="' + this.tipo.id + '" notas="' + this.notas + '">\n';
  nivelTabulacion++;
  
  for (var i=0; i<this.apunte.length; i++)
      contenido += this.apunte[i].verXML(nivelTabulacion);

  nivelTabulacion--;
  contenido += tabula(nivelTabulacion) + "</predefinido>\n";

  return contenido;
}/*}}}*/

function nuevoApuntePredefinido(){/*{{{*/
//Crea un nuevo Apunte en el Asiento Predefinido;
  nuevoApunte = new ApuntePredefinido()
  this.apunte[this.apunte.length] = nuevoApunte;

  return nuevoApunte;
}/*}}}*/

function borrarApuntePredefinido(apunte){/*{{{*/
  //Basta con eliminar la referencia en el array de apuntes del asiento
  var i=0;
  while ((i<this.apunte.length) && (this.apunte[i++] != apunte))
    ;
  while (i<this.apunte.length)
    this.apunte[i - 1] = this.apunte[i++];
  this.apunte[i - 1] = null;
  this.apunte.length--;
}/*}}}*/

function borrarApuntesPredefinido(){/*{{{*/
//Borra todos los apuntes del Asiento
  this.apunte = new Array();
}/*}}}*/

 /*}}}*/

//La clase Apunte de Predefinido/*{{{*/
function ApuntePredefinido(){/*{{{*/
	this.idCuenta = null;
	this.formula = null;

	this.verXML = verXMLApuntePredefinido;
}/*}}}*/

function verXMLApuntePredefinido(nivelTabulacion){/*{{{*/
  var contenido = new String();
  contenido = tabula(nivelTabulacion) + '<apuntePredefinido idCuenta="' + this.idCuenta + '" formula="' + this.formula + '" />\n';

  return contenido;
}/*}}}*/
/*}}}*/

// La clase Criterio/*{{{*/

function Criterio(){
  this.prevision = null;
  this.fechaDesde = null
  this.fechaHasta = null;
  this.idCuenta = null;
}/*}}}*/
