// Variables Globales/*{{{*/
var contabilidad = parent.parent.contabilidad;
var clienteSeleccionado;
var estadoIU = "Espera";

var observerCuenta = {
  getSupportedFlavours : function () {
    var flavours = new FlavourSet();
    flavours.appendFlavour("cuenta");
    return flavours;
  },
  onDragStart: function (evt, transferData, action){
    //Borramos la cuenta
    evt.target.setAttribute("value", "Arrastra Cuenta");
    evt.target.idCuenta = null;
  },
  onDrop: function (evt,dropdata,session){
    //Solo aceptamos cuentas finales
    var cuentaSeleccionada = contabilidad.verCuentaPorId(dropdata.data);
    if (cuentaSeleccionada.fin){
      evt.target.setAttribute("value", cuentaSeleccionada.nombre);
      evt.target.setAttribute("tooltiptext", cuentaSeleccionada.verNombreCompleto());
      evt.target.idCuenta = dropdata.data;
    }
  },
  onDragOver: function (evt, flav, dragSession){
    //Esta funcin hace falta aunque no haga nada.
  }
};  //Ojo a las , y al ;/*}}}*/

function iniciar(){/*{{{*/
  document.getElementById("labelCuenta").cuenta = null;
  verClientes();
 }/*}}}*/

function botonNuevo(){/*{{{*/
//Respuesta al botn Nuevo
  cambiarEstado("Insercin");
  borrarCampos();
}/*}}}*/

function botonEditar(){/*{{{*/
//Respuesta al botn Editar
  cambiarEstado("Edicin");
}/*}}}*/

function botonBorrar(){/*{{{*/
//Borra el cliente seleccionado, tras la confirmacin
  //Habra que comprobar que su cuenta est vaca
  if(confirm("Estas segura/o de que quieres BORRAR este cliente?")){
    contabilidad.borrarCliente(clienteSeleccionado);
    contabilidad.modificada = true;
    verClientes();
  }
 botonCancelar();
}/*}}}*/

function botonAceptar(){/*{{{*/ 
//Respuesta al botn Aceptar
  if (!comprobarCliente()) return;

  if (estadoIU == "Insercin") cliente = contabilidad.nuevoCliente();
  else cliente = clienteSeleccionado;

  cliente.nombre = document.getElementById("textboxNombre").value;
  cliente.nif = document.getElementById("textboxNif").value;
  cliente.idCuenta = document.getElementById("labelCuenta").idCuenta;

  contabilidad.modificada = true;

  //Refrescamos la lista de clientes
  verClientes();

  botonCancelar();
}/*}}}*/

function botonCancelar(){/*{{{*/
//Respuesta al botn Cancelar
  cambiarEstado("Espera");
  borrarCampos();
}/*}}}*/

function verClientes(){/*{{{*/
//Carga la lista de clientes
  listboxClientes = document.getElementById("listboxClientes");
  while (listboxClientes.removeItemAt(2)); //Borramos la lista
 
  //Los ordenamos
  contabilidad.cliente.sort(ordenarClientes);
  //Los presentamos
  for (var i=0; i<contabilidad.cliente.length; i++){
    item = document.createElement("listitem");
    itemCellNif = document.createElement("listcell");
    itemCellNombre = document.createElement("listcell");
    itemCellNif.setAttribute("label", contabilidad.cliente[i].nif);
    itemCellNombre.setAttribute("label", contabilidad.cliente[i].nombre);
    item.appendChild(itemCellNif);
    item.appendChild(itemCellNombre);
    //Y le aadimos el puntero al propio cliente
    item.cliente = contabilidad.cliente[i];
    listboxClientes.appendChild(item);
  }
}/*}}}*/

function cambiarEstado(estado){/*{{{*/
//Cambia el estado del Interfaz de Usuario
  estadoIU = estado;
  switch (estado){
    //Modos Pasivos
    case "Espera":
      document.getElementById("botonNuevo").removeAttribute("disabled");
      document.getElementById("botonEditar").setAttribute("disabled", "true");
      document.getElementById("botonBorrar").setAttribute("disabled", "true");
      document.getElementById("botonAceptar").setAttribute("disabled", "true");
      document.getElementById("botonCancelar").setAttribute("disabled", "true");
      document.getElementById("textboxNombre").setAttribute("disabled","true");
      document.getElementById("textboxNif").setAttribute("disabled","true");
      break;
    case "Consulta":
      document.getElementById("botonNuevo").removeAttribute("disabled");
      document.getElementById("botonEditar").removeAttribute("disabled");
      document.getElementById("botonBorrar").removeAttribute("disabled");
      document.getElementById("botonAceptar").setAttribute("disabled", "true");
      document.getElementById("botonCancelar").setAttribute("disabled", "true");
      document.getElementById("textboxNombre").setAttribute("disabled","true");
      document.getElementById("textboxNif").setAttribute("disabled","true");
      break;

    //Modos Activos
    case "Insercin":
    case "Edicin":
      document.getElementById("botonNuevo").setAttribute("disabled","true");
      document.getElementById("botonEditar").setAttribute("disabled", "true");
      document.getElementById("botonBorrar").setAttribute("disabled", "true");
      document.getElementById("botonAceptar").removeAttribute("disabled");
      document.getElementById("botonCancelar").removeAttribute("disabled");
      document.getElementById("textboxNombre").removeAttribute("disabled");
      document.getElementById("textboxNif").removeAttribute("disabled");
      break;
      
    default:
      alert("El estado " + estado + " es desconocido");
  }
}/*}}}*/

function borrarCampos(){/*{{{*/
//Borra el contenido de los campos del formulario de cliente
  document.getElementById("textboxNombre").value="";
  document.getElementById("textboxNif").value="";
  document.getElementById("labelCuenta").value="Arrastra Cuenta";
  document.getElementById("labelCuenta").cuenta=null;
}/*}}}*/

function mostrar(){/*{{{*/
//Muestra los datos del cliente en el formulario
  listboxClientes = document.getElementById("listboxClientes");
  if (((estadoIU == "Espera") || (estadoIU == "Consulta")) && (listboxClientes.selectedItem)) {
    cambiarEstado("Consulta");
    clienteSeleccionado = listboxClientes.selectedItem.cliente;

    document.getElementById("textboxNombre").value = clienteSeleccionado.nombre;
    document.getElementById("textboxNif").value = clienteSeleccionado.nif;
    var labelCuenta = document.getElementById("labelCuenta");
    if (clienteSeleccionado.idCuenta){
      labelCuenta.idCuenta = clienteSeleccionado.idCuenta;
      labelCuenta.cuenta = contabilidad.verCuentaPorId(clienteSeleccionado.idCuenta);
      labelCuenta.value = labelCuenta.cuenta.nombre;
      labelCuenta.setAttribute("tooltiptext", labelCuenta.cuenta.verNombreCompleto());
    }
    else{
      labelCuenta.cuenta = null;
      labelCuenta.value = "";
    }
  }
}/*}}}*/

function comprobarCliente(){/*{{{*/
//Comprueba la correccin de los datos del formulario
  //Nada que comprobar

  return true;
}/*}}}*/

function ordenarClientes(cliente1, cliente2){/*{{{*/
//Una sencilla funcin para ordenar los clientes por su nombre
  if (cliente1.nombre >= cliente2.nombre) return 1;
  else return -1;
}/*}}}*/
