// Variables Globales/*{{{*/
var contabilidad = parent.parent.contabilidad;
var proveedorSeleccionado;
var estadoIU = "Espera";

var observerCuenta = {
  getSupportedFlavours : function () {
    var flavours = new FlavourSet();
    flavours.appendFlavour("cuenta");
    return flavours;
  },
  onDragStart: function (evt, transferData, action){
    //Borramos la cuenta
    evt.target.setAttribute("value", "Arrastra Cuenta");
    evt.target.idCuenta = null;
  },
  onDrop: function (evt,dropdata,session){
    //Solo aceptamos cuentas finales
    var cuentaSeleccionada = contabilidad.verCuentaPorId(dropdata.data);
    if (cuentaSeleccionada.fin){
      evt.target.setAttribute("value", cuentaSeleccionada.nombre);
      evt.target.setAttribute("tooltiptext", cuentaSeleccionada.verNombreCompleto());
      evt.target.idCuenta = dropdata.data;
    }
  },
  onDragOver: function (evt, flav, dragSession){
    //Esta funcin hace falta aunque no haga nada.
  }
};  //Ojo a las , y al ;/*}}}*/

function iniciar(){/*{{{*/
  document.getElementById("labelCuenta").cuenta = null;
  verProveedores();
 }/*}}}*/

function botonNuevo(){/*{{{*/
//Respuesta al botn Nuevo
  cambiarEstado("Insercin");
  borrarCampos();
}/*}}}*/

function botonEditar(){/*{{{*/
//Respuesta al botn Editar
  cambiarEstado("Edicin");
}/*}}}*/

function botonBorrar(){/*{{{*/
//Borra el proveedor seleccionado, tras la confirmacin
  //Habra que comprobar que su cuenta est vaca
  if(confirm("Estas segura/o de que quieres BORRAR este proveedor?")){
    contabilidad.borrarProveedor(proveedorSeleccionado);
    contabilidad.modificada = true;
    verProveedores();
  }
 botonCancelar();
}/*}}}*/

function botonAceptar(){/*{{{*/ 
//Respuesta al botn Aceptar
  if (!comprobarProveedor()) return;

  if (estadoIU == "Insercin") proveedor = contabilidad.nuevoProveedor();
  else proveedor = proveedorSeleccionado;

  proveedor.nombre = document.getElementById("textboxNombre").value;
  proveedor.nif = document.getElementById("textboxNif").value;
  proveedor.cuentaBancaria = document.getElementById("textboxCuentaBancaria").value;
  proveedor.idCuenta = document.getElementById("labelCuenta").idCuenta;

  contabilidad.modificada = true;

  //Refrescamos la lista de proveedores
  verProveedores();

  botonCancelar();
}/*}}}*/

function botonCancelar(){/*{{{*/
//Respuesta al botn Cancelar
  cambiarEstado("Espera");
  borrarCampos();
}/*}}}*/

function verProveedores(){/*{{{*/
//Carga la lista de proveedores
  listboxProveedores = document.getElementById("listboxProveedores");
  while (listboxProveedores.removeItemAt(2)); //Borramos la lista
  
  //Ahora, ordenamos la lista
  contabilidad.proveedor.sort(ordenarProveedores);
  //Y la cargamos en el interfaz
  for (var i=0; i<contabilidad.proveedor.length; i++){
    item = document.createElement("listitem");
    itemCellNif = document.createElement("listcell");
    itemCellNombre = document.createElement("listcell");
    itemCellNif.setAttribute("label", contabilidad.proveedor[i].nif);
    itemCellNombre.setAttribute("label", contabilidad.proveedor[i].nombre);
    item.appendChild(itemCellNif);
    item.appendChild(itemCellNombre);
    //Y le aadimos el puntero al propio proveedor
    item.proveedor = contabilidad.proveedor[i];
    listboxProveedores.appendChild(item);
  }
}/*}}}*/

function cambiarEstado(estado){/*{{{*/
//Cambia el estado del Interfaz de Usuario
  estadoIU = estado;
  switch (estado){
    //Modos Pasivos
    case "Espera":
      document.getElementById("botonNuevo").removeAttribute("disabled");
      document.getElementById("botonEditar").setAttribute("disabled", "true");
      document.getElementById("botonBorrar").setAttribute("disabled", "true");
      document.getElementById("botonAceptar").setAttribute("disabled", "true");
      document.getElementById("botonCancelar").setAttribute("disabled", "true");
      document.getElementById("textboxNombre").setAttribute("disabled","true");
      document.getElementById("textboxNif").setAttribute("disabled","true");
      document.getElementById("textboxCuentaBancaria").setAttribute("disabled","true");
      break;
    case "Consulta":
      document.getElementById("botonNuevo").removeAttribute("disabled");
      document.getElementById("botonEditar").removeAttribute("disabled");
      document.getElementById("botonBorrar").removeAttribute("disabled");
      document.getElementById("botonAceptar").setAttribute("disabled", "true");
      document.getElementById("botonCancelar").setAttribute("disabled", "true");
      document.getElementById("textboxNombre").setAttribute("disabled","true");
      document.getElementById("textboxNif").setAttribute("disabled","true");
      document.getElementById("textboxCuentaBancaria").setAttribute("disabled","true");
      break;

    //Modos Activos
    case "Insercin":
    case "Edicin":
      document.getElementById("botonNuevo").setAttribute("disabled","true");
      document.getElementById("botonEditar").setAttribute("disabled", "true");
      document.getElementById("botonBorrar").setAttribute("disabled", "true");
      document.getElementById("botonAceptar").removeAttribute("disabled");
      document.getElementById("botonCancelar").removeAttribute("disabled");
      document.getElementById("textboxNombre").removeAttribute("disabled");
      document.getElementById("textboxNif").removeAttribute("disabled");
      document.getElementById("textboxCuentaBancaria").removeAttribute("disabled");
      break;
      
    default:
      alert("El estado " + estado + " es desconocido");
  }
}/*}}}*/

function borrarCampos(){/*{{{*/
//Borra el contenido de los campos del formulario de proveedor
  document.getElementById("textboxNombre").value="";
  document.getElementById("textboxNif").value="";
  document.getElementById("textboxCuentaBancaria").value="";
  document.getElementById("labelCuenta").value="Arrastra Cuenta";
  document.getElementById("labelCuenta").cuenta=null;
  
}/*}}}*/

function mostrar(){/*{{{*/
//Muestra los datos del proveedor en el formulario
  listboxProveedores = document.getElementById("listboxProveedores");
  if (((estadoIU == "Espera") || (estadoIU == "Consulta")) && (listboxProveedores.selectedItem)) {
    cambiarEstado("Consulta");
    proveedorSeleccionado = listboxProveedores.selectedItem.proveedor;

    document.getElementById("textboxNombre").value = proveedorSeleccionado.nombre;
    document.getElementById("textboxNif").value = proveedorSeleccionado.nif;
    document.getElementById("textboxCuentaBancaria").value = proveedorSeleccionado.cuentaBancaria;
    var labelCuenta = document.getElementById("labelCuenta");
    if (proveedorSeleccionado.idCuenta){
      labelCuenta.idCuenta = proveedorSeleccionado.idCuenta;
      labelCuenta.cuenta = contabilidad.verCuentaPorId(proveedorSeleccionado.idCuenta);
      labelCuenta.value = labelCuenta.cuenta.nombre;
      labelCuenta.setAttribute("tooltiptext", labelCuenta.cuenta.verNombreCompleto());
    }
    else{
      labelCuenta.cuenta = null;
      labelCuenta.value = "";
    }
  }
}/*}}}*/

function comprobarProveedor(){/*{{{*/
//Comprueba la correccin de los datos del formulario
  //Nada que comprobar
  return true;
}/*}}}*/

function ordenarProveedores(proveedor1, proveedor2){/*{{{*/
//Una sencilla funcin para ordenar los proveedores por su nombre
  if (proveedor1.nombre >= proveedor2.nombre) return 1;
  else return -1;
}/*}}}*/
